misc = {}
const = {}
const.frameTime = 1000/50
const.image = {}
const.image.floor = 0
const.image.top = 1
const.image.hud = 2
const.image.super = 3
const.align = {}
const.align.left = 0
const.align.center = 1
const.align.right = 2
const.map = {}
const.map.xsize = map("xsize")
const.map.ysize = map("ysize")
print("map x: "..const.map.xsize)

const.buildings = {}
const.buildings[1] = {
    name="Barricade",
    price=100,
    buildable=true,
    walkable=false
    }
const.buildings[2] = {
    name="Barbed Wire",
    price=500,
    buildable=true,
    walkable=true
    }
const.buildings[3] = {
    name="Wall I",
    price=1000,
    buildable=true,
    walkable=false
    }
const.buildings[4] = {
    name="Wall II",
    price=2000,
    buildable=true,
    walkable=false
    }
const.buildings[5] = {
    name="Wall II",
    price=3000,
    buildable=true,
    walkable=false
    }
const.buildings[6] = {
    name="Gate Field",
    price=1500,
    buildable=true,
    walkable=true
    }
const.buildings[7] = {
    name="Dispenser",
    price=5000,
    buildable=true,
    walkable=false
    }
const.buildings[8] = {
    name="Turret",
    price=5000,
    buildable=true,
    walkable=false
    }
const.buildings[9] = {
    name="Supply",
    price=5000,
    buildable=true,
    walkable=false
    }
const.buildings[10] = {
    name="Construction Site",
    price=0,
    buildable=false,
    walkable=false
    }
const.buildings[11] = {
    name="Dual Turret",
    price=0,
    buildable=false,
    walkable=false
    }
const.buildings[12] = {
    name="Triple Turret",
    price=0,
    buildable=false,
    walkable=false
    }
const.buildings[13] = {
    name="Teleporter Entrance",
    price=3000,
    buildable=true,
    walkable=true
    }
const.buildings[14] = {
    name="Teleporter Exit",
    price=3000,
    buildable=true,
    walkable=true
    }

-- convert tiles to pixel, for example, 32 pixels becomes 1.5 tiles
function misc.pixel_to_tile(pixel)
	return misc.round((pixel-16)/32)
end

-- convert tiles to pixel, for example, 1 tile becomes 16
function misc.tile_to_pixel(tile)
	return (tile*32)+16
end

-- calculate the direction beetween 2 points
function misc.point_direction(x1,y1,x2,y2)
	return -math.deg(math.atan2(x1-x2,y1-y2))
end

-- calculate the distance beetween 2 points
function misc.point_distance(x1,y1,x2,y2)
	return math.sqrt((x1-x2)^2 + (y1-y2)^2)
end

-- primitive way to calculate the distance beetween 2 points
function misc.primitive_point_distance(x1,y1,x2,y2)
    return math.max(math.abs(x1-x2),math.abs(y1-y2))
end

-- use for movement calculation (X)
function misc.lengthdir_x(dir,length)
	return math.cos(math.rad(dir - 90))*length
end

-- use for movement calculation (Y)
function misc.lengthdir_y(dir,length)
	return math.sin(math.rad(dir - 90))*length
end

function misc.check(data1,data2) -- compares 2 variables (table?), useful to save space (might malfunctions)
    if (type(data1) == "table") then
        local i = 0
        while (i < #data1) do
            i = i + 1
            if (type(data2) == "table") then
                local ii = 0
                while (ii < #data2) do
                    ii = ii + 1
                    if (data1[i] == data2[ii]) then
                        return true
                    end
                end
            else
                if (data1[i] == data2) then
                    return true
                end
            end
        end
        return false
    else
        if (type(data2) == "table") then
            local ii = 0
            while (ii < #data2) do
                ii = ii + 1
                if (data1[i] == data2[ii]) then
                    return true
                end
            end
        else
            if (data1 == data2) then
                return true
            end
        end
        return false
    end
end


function misc.split_text(text)
    --[[ OLD technique, ps. this will updated again!
	local command_input = {}
	for word in string.gmatch(text, "[!-z]+") do
		command_input[#command_input+1] = word
	end
	return command_input
    ]]--
	local command_input = {}
	for word in string.gmatch(text, "[!-z]+") do
        if (not(tonumber(word) == nil)) then
            word = tonumber(word)
        end
		command_input[#command_input+1] = word
	end
	return command_input
end

function misc.fileExists(file)
    local f = io.open(file,"r")
    if f == nil then
        return false
    else
        f:close()
        return true
    end
   --if f~=nil then io.close(f) return true else return false end
end
--	local file_check = io.open(file,"r")
--	if file_check == nil then
--		return false
--	end
--	file_check:close()
--	return true
--end
misc.timeTranslatorCharDefault = 1
misc.timeTranslatorChar = {
{c="s",t=1,s="Second"}, -- default
{c="m",t=60,s="Minute"},
{c="h",t=60*60,s="Hour"},
{c="d",t=60*60*24,s="Day"},
{c="w",t=60*60*24*7,s="Week"},
{c="M",t=60*60*24*30,s="Month"},
{c="y",t=60*60*24*365,s="Year"}}
function misc.timeTranslator(timeString)
    local totalTime = 0
    local latest_num = ""
	local i = 0
    while (i < string.len(timeString)) do
        i = i + 1
        c = string.sub(timeString,i,i)
        if tonumber(c) == nil then
            if latest_num == "" then -- FAIL: the time was empty
                misc.timeTranslator_error = i-1
                return false
            end
            local found_c = false
            local ii = 0
            while (ii < #misc.timeTranslatorChar) do
                ii = ii + 1
                if misc.timeTranslatorChar[ii].c == c then
                    found_c = true
                    local temp = tonumber(latest_num)
                    latest_num = ""
                    totalTime = totalTime + (temp*misc.timeTranslatorChar[ii].t)
                    break
                end
            end
            if not(found_c) then
                misc.timeTranslator_error = i
                return false
            end
        else
            latest_num = latest_num..c
        end
    end
    if not(latest_num == "") then --missing type? assuming seconds
        local temp = tonumber(latest_num)
        totalTime = totalTime + (temp*misc.timeTranslatorChar[misc.timeTranslatorCharDefault].t)
    end
    return totalTime
end

function misc.secondsToString(seconds)
    str = ""
    check_index = #misc.timeTranslatorChar
    while (check_index > 0) do
        local timeNum =  math.floor(seconds / misc.timeTranslatorChar[check_index].t)
        seconds = seconds - (timeNum*misc.timeTranslatorChar[check_index].t)
        -- [] --
        if (timeNum > 0) then
            type_name = misc.timeTranslatorChar[check_index].s
            if (timeNum > 1) then
                type_name = type_name.."'s"
            end
            str = timeNum.." "..type_name.." "..str
        end
        check_index = check_index - 1
    end
    return str
end

function misc.translateTimeErr(id,time_) -- with error handling
    result = misc.timeTranslator(time_)
    if result == false then
        local err = misc.timeTranslator_error
        local err_pos = err
        if err == 0 then
            err_pos = 1
        end
        msg2(id,misc.rgb(255,0,0).."Error at position "..err_pos)
        if err == 0 then
            msg2(id,misc.rgb(255,0,0)..command[2])
        else
            msg2(id,misc.rgb(0,255,0)..string.sub(command[2],1,err-1)..misc.rgb(255,0,0)..string.charAt(command[2],err)..misc.rgb(255,255,0)..string.sub(command[2],err+1))
        end
        pre = ""
        if err > 0 then
            pre = misc.rgb(0,255,0)..string.sub(command[2],1,err-1)--string.rep("_",err)
        end
        msg2(id,pre..misc.rgb(255,0,0).."^")
        return false
    else
        return result
    end
end

--addhook("say","misc.say") -- used in testing the !time command
function misc.say(id,text)
    command = misc.split_text(text)
    if command[1] == "!time" then
        result = misc.timeTranslator(command[2])
        if result == false then
            local err = misc.timeTranslator_error
            local err_pos = err
            if err == 0 then
                err_pos = 1
            end
            msg(misc.rgb(255,0,0).."Error at position "..err_pos)
            if err == 0 then
                msg(misc.rgb(255,0,0)..command[2])
            else
                msg(misc.rgb(0,255,0)..string.sub(command[2],1,err-1)..misc.rgb(255,0,0)..string.charAt(command[2],err)..misc.rgb(255,255,0)..string.sub(command[2],err+1))
            end
            pre = ""
            if err > 0 then
                pre = misc.rgb(0,255,0)..string.sub(command[2],1,err-1)--string.rep("_",err)
            end
            msg(pre..misc.rgb(255,0,0).."^")
            --return 1
        else
            msg("Data returned: "..result.." Seconds")
            msg("aka: "..misc.secondsToString(result))
        end
        --return 1
    end
end

function misc.isNearPlayers(x,y,dist,exception)
	local pl = player(0,"tableliving")
	for i=1,#pl do
		if player(pl[i],"x") < x+dist and player(pl[i],"x") > x-dist and player(pl[i],"y") < y+dist and player(pl[i],"y") > y-dist then
            if (type(exception) == "table") then
                hit = true
                ii = 0
                while (ii < #exception) do
                    ii = ii + 1
                    if (pl[i] == exception[ii]) then
                        hit = false
                    end
                end
                if (hit) then
                    return pl[i]
                end
            else
                return pl[i]
            end
		end
	end
	return 0
end

function misc.round(num,base)
	if base == nil then
		return math.floor(num+0.5)
	else
        if base > 0 then
            base = math.pow(10,base)
        end
		return math.floor((num*base)+0.5)/base
	end
end

function misc.thousandMarks(number)
    local new_str = ""
    local dist_count = 0
    local str_num = tostring(number)
    if number < 0 then
        str_num = str_num:sub(2)
    end
    local i = string.len(str_num)
    while (i > 0) do
        dist_count = dist_count + 1
        if dist_count == 4 then
            dist_count = 0
            new_str = "'"..new_str
        end
        local c = str_num:sub(i,i)
        new_str = c..new_str
        i = i - 1
    end
    if number < 0 then
        new_str = "-"..new_str
    end
    return new_str
end

function misc.debugImage(x,y,r,g,b,t)
	local temp = image("gfx/hud_dot.bmp",x,y,3)
	if t == nil then
		t = 1000
	end
    if (t > 0) then
        timer(t,"freeimage",temp)
    end
	if (r == nil) == false then
		imagecolor(temp,r,g,b)
	end
end

misc.hudtxtID = {}
for i=0,49 do
    misc.hudtxtID[i] = nil
end

function misc.get_hudtxt()
    first_id = #misc.hudtxtID
    misc.hudtxtID[first_id+1] = true
    return first_id
end

function misc.drop_hudtxt(id)
    misc.hudtxtID[id] = nil
end

misc.playerHudtxt = {}

addhook("join","misc.join")
function misc.join(id)
    misc.playerHudtxt[id] = {}
    for i=0,49 do
        misc.playerHudtxt[id][i] = ""
    end
end

function misc.hudTextEveryone(id,text,x,y,align)
    parse("hudtxt "..id.." \""..text.."\" "..x.." "..y.." "..align.."")
end

function misc.hudText(id,pid,text,x,y,align)
    if pid == 0 then
        misc.hudTextEveryone(id,text,x,y,align)
    else
        if (not (misc.playerHudtxt[pid][id] == text)) then
            misc.playerHudtxt[pid][id] = text
            parse("hudtxt2 "..pid.." "..id.." \""..text.."\" "..x.." "..y.." "..align)
        end
    end
end

function misc.hudTextFade(id,pid,duration,alpha)
	parse("hudtxtalphafade "..pid.." "..id.." "..duration.." "..alpha.."")
	return id
end

function misc.hudTextColor(id,pid,duration,r,g,b)
	parse("hudtxtcolorfade "..pid.." "..id.." "..duration.." "..r.." "..g.." "..b.."")
	return id
end

function misc.explosion(x,y,size,dmg,src)
	parse("explosion "..x.." "..y.." "..size.." "..dmg.." "..src)
end

function misc.effect(effect,x,y,amount,radius,r,g,b)
    parse("effect \""..effect.."\" "..x.." "..y.." "..amount.." "..radius.." "..r.." "..g.." "..b)
end

misc.armourValue = {{id=206,protection=0}, -- stealth armour
{id=205,protection=95}, -- super armour
{id=204,protection=0}, -- medic armour
{id=203,protection=75}, -- heavy armour
{id=202,protection=50}, -- medium armour
{id=201,protection=25}} -- light armour
function misc.calcDamage(id,dmg)
	local armor = player(id,"armor")
	for i=1,#misc.armourValue do
		if armor == misc.armourValue[i].id then
			return dmg - ((dmg / 100) * misc.armourValue[i].protection)
		end
	end
	return dmg
end

-- DISCLAIMER: NOT created by me, source: http://snippets.luacode.org/snippets/Shuffle_array_145
function misc.shuffle_array(ar)
    local n, order, res = #ar, {}, {}
     
    for i=1,n do order[i] = { rnd = math.random(), idx = i } end
    table.sort(order, function(a,b) return a.rnd < b.rnd end)
    for i=1,n do res[i] = ar[order[i].idx] end
    return res
end

function misc.colorTextPercent(percent)
	if percent < 0 then
		percent = 0
	end
	if percent > 100 then
		percent = 100
	end
	local r = misc.round(255-(percent*2.55))
	local g = misc.round(percent*2.55)
	local b = 0
    local yellowBoost = (50-(math.abs(percent-50)))
    if yellowBoost > 0 then
        yellowBoost = yellowBoost*2.55
    end
    r = r + yellowBoost
    g = g + yellowBoost
    r = math.floor(r)
    g = math.floor(g)
    b = math.floor(b)
	return ("©"..misc.minimum_3(r)..misc.minimum_3(g)..misc.minimum_3(b))
end

function misc.rgb(r,g,b)
	return ("©"..misc.minimum_3(r)..misc.minimum_3(g)..misc.minimum_3(b))
end

-- PRIVATE function
function misc.minimum_3(text)-- you arent really intended to use this function
	text = tostring(text)
	while (string.len(text) < 3) do
		text = "0"..text
	end
	return text
end

function misc.eval(code)
	file = io.open("sys/lua/eval.lua","w")
	if type(code) == "string" then
		file:write(code)
	end
	if type(code) == "table" then
		i = 0
		while (i < #code) do
			i = i + 1
			file:write(code[i])
		end
	end
	file:close()
	ret = dofile("sys/lua/eval.lua")
	os.remove("sys/lua/eval.lua")
	return ret
end

-- sense CS2D reads servertransfer BEFORE lua, you might need to restart, after your lua used this function

--if you want this function, then BE IN MIND that the current content in servertransfer.lst will be erased!

misc.doAddServerTransfer = true

if misc.doAddServerTransfer then
    file = io.open("sys/servertransfer.lst","w")
    file:write("")
    file:close()
end

function misc.addServerTransfer(fileDir)
    if misc.doAddServerTransfer then
        print("added "..fileDir.." to serverTransfer.lst")
        file = io.open("sys/servertransfer.lst","a")
        file:write(fileDir.."\n")
        file:close()
    end
end

-- originally created by: http://gmc.yoyogames.com/index.php?showtopic=433253
-- converted to lua and modified by Endercrypt
function misc.turnTowards(direction, wdir, turnspeed)
    angdiff = ((((direction - wdir) % 360) + 540) % 360) - 180;
    return (direction - math.min(math.max(angdiff,-turnspeed),turnspeed)) % 360
end

function misc.maxmin(num,maxmin_num)
    return math.min(math.max(num,-maxmin_num),maxmin_num)
end

function misc.tableSwap(table_,index)
    table_[index] = table_[#table_]
    table_[#table_] = nil
end

function misc.cord_inside_map(x,y) -- tile coordinates
    return ((x > 0) and (y > 0) and (x <= const.map.xsize) and (y <= const.map.ysize))
end

misc.mp_hud_data = {{"Health",true},{"Armor",true},{"Time",true},{"Ammo",true},{"Money",true},{"Icons",true},{"Kill",true}}

-- misc.mp_hud(Health,Armor,Time,Ammo,Money,Icons,Kill) --true or false
function misc.mp_hud(...)
    local arg = {...}
    local mult = 0.5
    for i=1,#arg do
        mult = mult * 2
        msg(tostring(arg[i]))
        misc.mp_hud_data[i][2] = arg[i]
    end
    misc.mp_hud_commit()
end

function misc.mp_hud_change(code_string,on_off)
    for i=1,#misc.mp_hud_data do
        local data_string = misc.mp_hud_data[i][1]
        if (string.lower(code_string) == string.lower(data_string)) then
            misc.mp_hud_data[i][2] = on_off
            break
        end
    end
    misc.mp_hud_commit()
end

function misc.mp_hud_commit() -- internal, dont call unless you changed "misc.mp_hud_data" manually
    local value = 0
    local mult = 0.5
    for i=1,#misc.mp_hud_data do
        mult = mult * 2
        local data_value = misc.mp_hud_data[i][2]
        --msg(tostring(data_value))
        if (data_value) then
            value = value + mult
        end
    end
    parse("mp_hud "..value)
end

function misc.playerPos()
    local pl = player(0,"table")
    local data = {}
    data.living = {byCount={},byId={}} -- count from 1 and up, through all players
    data.all = {byCount={},byId={}} -- use id as index
    for i=1,#pl do
        local user = {}
        user.id = pl[i]
        user.x = player(user.id,"x")
        user.y = player(user.id,"y")
        user.alive = (player(user.id,"health") > 0)
        -- reference it
        data.all.byCount[#data.all.byCount+1] = user
        data.all.byId[user.id] = user
        if user.alive then
            data.living.byCount[#data.living.byCount+1] = user
            data.living.byId[user.id] = user
        end
    end
    return data
end

------------------------
--[ EXTENSION ]--
------------------------

function isNil(value) -- example: nil
    return (value == nil)
end

function isString(value) -- example: "9001" or "lol"
    return (type(value) == "string")
end

function isNumber(value) -- example: 9001
    return (type(value) == "number")
end

function isNumberValue(value) -- example: "9001"
    return (type(tonumber(value)) == "number")
end

------------------------
--[ STRING EXTENSION ]--
------------------------

function string.charAt(str,num)
    return string.sub(str,num,num)
end

-----------------------
--[ TABLE EXTENSION ]--
-----------------------

function table.shallowCopy(orig)
    local orig_type = type(orig)
    local copy
    if orig_type == 'table' then
        copy = {}
        for orig_key, orig_value in pairs(orig) do
            copy[orig_key] = orig_value
        end
    else -- number, string, boolean, etc
        copy = orig
    end
    return copy
end

function table.val_to_str ( v )
  if "string" == type( v ) then
    v = string.gsub( v, "\n", "\\n" )
    if string.match( string.gsub(v,"[^'\"]",""), '^"+$' ) then
      return "'" .. v .. "'"
    end
    return '"' .. string.gsub(v,'"', '\\"' ) .. '"'
  else
    return "table" == type( v ) and table.tostring( v ) or
      tostring( v )
  end
end

function table.key_to_str ( k )
  if "string" == type( k ) and string.match( k, "^[_%a][_%a%d]*$" ) then
    return k
  else
    return "[" .. table.val_to_str( k ) .. "]"
  end
end

function table.tostring( tbl )
  local result, done = {}, {}
  for k, v in ipairs( tbl ) do
    table.insert( result, table.val_to_str( v ) )
    done[ k ] = true
  end
  for k, v in pairs( tbl ) do
    if not done[ k ] then
      table.insert( result,
        table.key_to_str( k ) .. "=" .. table.val_to_str( v ) )
    end
  end
  return "{" .. table.concat( result, "," ) .. "}"
end

----------------------
--[ CS2D EXTENSION ]--
----------------------

function msg3(id,text,optionalLivingOnly)
    local pl = player(0,"table")
    local i = 0
    while(i < #pl) do
        i = i + 1
        if ((id == pl[i]) == false) then
            msg(pl[i],text)
        end
    end
end


-----[ Created by EnderCrypt ]-----
function hook(hook_name,func)
    local func_temp = function()
    end
    while (type(func_temp) == "function") do
        func_name = "random_function_"..math.random(9999,99999999)
        func_temp = misc.eval("return "..func_name)
    end
    func_global = func
    misc.eval({func_name.." = func_global"})
    addhook(hook_name,func_name)
    return func_temp
end
-----[ Created by EnderCrypt ]-----
function Class(namespace,constructor)
    namespace.__index = namespace
    namespace.new = function(...)
        --local this = {}
        local this = {}
        self = this
        setmetatable(this,namespace)
        constructor(unpack(arg))
        return this
    end
end
-----[ Created by EnderCrypt ]-----
AutoMapper = {}

Class(AutoMapper,function(func)
    self.map = {}
    x = 0
    while (x < const.map.xsize+1) do
        x = x + 1
        self.map[x] = {}
        y = 0
        while (y < const.map.ysize+1) do
            y = y + 1
            self.map[x][y] = func(x-1,y-1)
        end
    end
end)

function AutoMapper:get(x,y)--,default)
    x = x + 1
    y = y + 1
    --if (default == nil) then
        return self.map[x][y]
    --else
        --if ((x > 0) and (y > 0) and (x <= const.map.xsize) and (y <= const.map.ysize)) then
            --return self.map[x][y]
        --else
            --return default
        --end
    --end
end
-----[ Created by EnderCrypt ]-----
InspectAlarm = {}
InspectAlarm.specificTile = {}

function InspectAlarm.addSpecificTile(x,y,knife_trigger,weapon_trigger)
    local temp = {}
    temp.x = x
    temp.y = y
    temp.trigger = {knife=knife_trigger,weapon=weapon_trigger}
    InspectAlarm.specificTile[#InspectAlarm.specificTile+1] = temp
end

-- Add specific tiles HERE --

InspectAlarm.addSpecificTile(81,122,"Clear","Alarm")

-- end -- 

InspectAlarm.map = AutoMapper.new(function(x,y)
    local this = {}
    this.frame = tile(x,y,"frame")
    this.scanner = false
    return this
end)

local i = 0
while (i < #InspectAlarm.specificTile) do
    i = i + 1
    local tile_data = InspectAlarm.specificTile[i]
    local map_tile_data = InspectAlarm.map:get(tile_data.x,tile_data.y)
    map_tile_data.scanner = true
    map_tile_data.trigger = tile_data.trigger
end


hook("movetile",function(id,x,y)
    local tile_data = InspectAlarm.map:get(x,y)
    if tile_data.scanner then
        local weapons = playerweapons(id)
        if #weapons == 1 then
            -- just knife
            --msg("knife")
            parse("trigger "..tile_data.trigger.knife)
        else
            -- weapons
            --msg("weapon")
            parse("trigger "..tile_data.trigger.weapon)
        end
    end
end)